--[[	*** Historia ***
Written by : Yukyuk, EU-Moonglade
--]]

-------------------------------------------------------------------------------
--  AddOn name space.
-------------------------------------------------------------------------------
local FOLDER_NAME, private = ...


-------------------------------------------------------------------------------
--  Libstubs.
-------------------------------------------------------------------------------
local L 		= LibStub("AceLocale-3.0"):GetLocale("Historia")


-------------------------------------------------------------------------------
--  Configuration table.
-------------------------------------------------------------------------------
local cfg 	= {}
private.cfg = cfg


-------------------------------------------------------------------------------
--  AddOn configuration constants.
-------------------------------------------------------------------------------
cfg.addon_name 			= "Historia"
cfg.addon_version 		= "v3.0"	
cfg.ADDON_WIDTH = 866
cfg.ADDON_HEIGHT = 512
cfg.ADDON_YS = "0"
cfg.ADDON_MS = "0"
cfg.ADDON_DS = "0"


-------------------------------------------------------------------------------
--  Folder for the Icons.
-------------------------------------------------------------------------------
cfg.Icons = "Interface\\Addons\\Historia\\Icons\\"


-------------------------------------------------------------------------------
--  Player constants.
-------------------------------------------------------------------------------
cfg.PLAYER_NAME		= _G.UnitName("player")
cfg.PLAYER_CLASS_DISPLAYNAME, cfg.PLAYER_CLASS, cfg.PLAYER_CLASS_ID = UnitClass("player")
cfg.PLAYER_FACTION 	= _G.UnitFactionGroup("player")
cfg.PLAYER_LEVEL 	= _G.UnitLevel("player")
cfg.PLAYER_GENDER 	= _G.UnitSex("player")
cfg.PLAYER_RACE		= _G.UnitRace("player")

if cfg.PLAYER_GENDER == 2 then
	cfg.PLAYER_GENDER_TEXT = MALE
else	
	cfg.PLAYER_GENDER_TEXT = FEMALE
end	

cfg.REALM_NAME 		= _G.GetRealmName()


-------------------------------------------------------------------------------
--  Default backdrops
-------------------------------------------------------------------------------
cfg.Historia_backdrop0 = {
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = false, tileSize = 8, edgeSize = 8,
	insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}	
	
cfg.Historia_backdrop1 = {
	bgFile = "Interface\\ACHIEVEMENTFRAME\\UI-GuildAchievement-AchievementBackground",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = false, tileSize = 8, edgeSize = 8,
	insets = { left = 2, right = 2, top = 2, bottom = 2 }
	}
	
cfg.Historia_backdrop2 = {
	bgFile = "Interface\\ACHIEVEMENTFRAME\\UI-GuildAchievement-Parchment-Horizontal-Desaturated",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = false, tileSize = 8, edgeSize = 8,
	insets = { left = 2, right = 2, top = 2, bottom = 2 }
	}	
	
cfg.Historia_backdrop3 = {
	bgFile = "Interface\\ACHIEVEMENTFRAME\\UI-GuildAchievement-AchievementBackground",
	tile = false, tileSize = 8, edgeSize = 8,
	insets = { left = 2, right = 2, top = 2, bottom = 2 }
	}	
	
	
-------------------------------------------------------------------------------
--  Table  with the Currency textures.
-------------------------------------------------------------------------------
cfg.CTX = {
	"Interface\\COMMON\\Indicator-Gray",
	"Interface\\COMMON\\Indicator-Green",
	"Interface\\COMMON\\Indicator-Red",
	"Interface\\COMMON\\Indicator-Yellow",	
	}	
	
	
-------------------------------------------------------------------------------
--	Profession Expansion colors
-------------------------------------------------------------------------------
cfg.colors = {
	["Classic"] = "\124cffFFD700",				-- Gold
	["Kul"] = "\124cffC0C0C0",					-- Silver
	["Zandalari"] = "\124cffC0C0C0",			-- Silver
	["Legion"] = "\124cff90EE90",				-- Light Green
	["Draenor"] = "\124cffD2691E",				-- Chocolate
	["Pandaria"] = "\124cff2E8B57",				-- Sea Green
	["Cataclysm"] = "\124cffFF4500",			-- Orange Red
	["Northrend"] = "\124cffB0C4DE",			-- Light Steel Blue		
	["Outland"] = "\124cff228B22",				-- Forest Green
	["Way of the Brew"] = "\124cff2E8B57",		-- Sea Green
	["Way of the Grill"] = "\124cff2E8B57",		-- Sea Green
	["Way of the Oven"] = "\124cff2E8B57",		-- Sea Green
	["Way of the Pot"] = "\124cff2E8B57",		-- Sea Green
	["Way of the Steamer"] = "\1242E8B57",		-- Sea Green
	["Way of the Wok"] = "\124cff2E8B57",		-- Sea Green
	["End"] = "\124r",
	}
	
	
-------------------------------------------------------------------------------
--  Table  with the profession Id's, and textures.
--	1 = SkilId
--	2 = Name (English)
--	3 = TextureId	
--	4 = Learned or not (by default false, used in the professions tab)
-------------------------------------------------------------------------------
cfg.PTX_Relevant = 15	--	Pandarians way's are not relevant for filling professions tabs
cfg.PTX = {
	[1] = 	{[1] = 164,[2] = L["Blacksmithing"],		[3] = 136241,[4] = false},
	[2] = 	{[1] = 165,[2] = L["Leatherworking"],		[3] = 136247,[4] = false},
	[3] = 	{[1] = 171,[2] = L["Alchemy"],				[3] = 136240,[4] = false},
	[4] = 	{[1] = 182,[2] = L["Herbalism"],			[3] = 136246,[4] = false},
	[5] = 	{[1] = 185,[2] = L["Cooking"],				[3] = 133971,[4] = false},
	[6] = 	{[1] = 186,[2] = L["Mining"],				[3] = 134708,[4] = false},
	[7] = 	{[1] = 197,[2] = L["Tailoring"],			[3] = 136249,[4] = false},
	[8] = 	{[1] = 202,[2] = L["Engineering"],			[3] = 136243,[4] = false},
	[9] = 	{[1] = 333,[2] = L["Enchanting"],			[3] = 136244,[4] = false},
	[10] = 	{[1] = 356,[2] = L["Fishing"],				[3] = 136245,[4] = false},
	[11] = 	{[1] = 393,[2] = L["Skinning"],				[3] = 134366,[4] = false},
	[12] = 	{[1] = 755,[2] = L["Jewelcrafting"],		[3] = 134071,[4] = false},
	[13] = 	{[1] = 773,[2] = L["Inscription"],			[3] = 237171,[4] = false},
	[14] = 	{[1] = 794,[2] = L["Archaeology"],			[3] = 441139,[4] = false},	
	[15] = 	{[1] = 129,[2] = L["First Aid"],			[3] = "Interface\\ICONS\\Spell_Holy_SealOfSacrifice",[4] = false},
	[16] = 	{[1] = 185,[2] = L["Way of the Brew"],		[3] = 133971,[4] = false},
	[17] = 	{[1] = 185,[2] = L["Way of the Grill"],		[3] = 133971,[4] = false},
	[18] = 	{[1] = 185,[2] = L["Way of the Oven"],		[3] = 133971,[4] = false},
	[19] = 	{[1] = 185,[2] = L["Way of the Pot"],		[3] = 133971,[4] = false},
	[20] = 	{[1] = 185,[2] = L["Way of the Steamer"],	[3] = 133971,[4] = false},
	[21] = 	{[1] = 185,[2] = L["Way of the Wok"],		[3] = 133971,[4] = false},	
	}	

	
-------------------------------------------------------------------------------
--	Historia Achievement and Quest numbers 
--	Both used is several lua files so in cfg
-------------------------------------------------------------------------------	
cfg.Historia_HIA1_Buttons = 6
cfg.Historia_HIQ1_Buttons = 12
cfg.Historia_HIA1_Text = {1,23,45,67,89,123}	
cfg.Historia_HIQ1_Text = {1,23,45,67,89,123,456,789,1234,2345,3456,4567}


-------------------------------------------------------------------------------	
--  Table to transform a month number into a month name.
-------------------------------------------------------------------------------
cfg.Historia_month_table = {FULLDATE_MONTH_JANUARY, 
						FULLDATE_MONTH_FEBRUARY, 
						FULLDATE_MONTH_MARCH, 
						FULLDATE_MONTH_APRIL, 
						FULLDATE_MONTH_MAY,
						FULLDATE_MONTH_JUNE,
						FULLDATE_MONTH_JULY,
						FULLDATE_MONTH_AUGUST,
						FULLDATE_MONTH_SEPTEMBER,
						FULLDATE_MONTH_OCTOBER,
						FULLDATE_MONTH_NOVEMBER,
						FULLDATE_MONTH_DECEMBER
						}

						
--  Format the date(s) to a readable form
cfg.Historia_FormatDate = function(year, month, day)
	local DF_year = year
	local DF_month = month
	local DF_day = day
	local date_string
	
	if day == "" then
		date_string = format(cfg.Historia_month_table[tonumber(DF_month)] .. " " .. year)
	else
		date_string = format(cfg.Historia_month_table[tonumber(DF_month)] .. " " .. day .. " " .. year)
	end	

	return date_string
end	


--------------------------------------------------------------------------------
--  Button factory for Hievements tab tool tips
--------------------------------------------------------------------------------
cfg.Historia_Button_OnEnter = function(self)
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT", 0, -8)
	GameTooltip:SetText(self.tooltipText, nil, nil, nil, nil, true)
	GameTooltip:Show()
end


cfg.Historia_Button_OnLeave = function()
	GameTooltip_Hide()
end


--  If text is provided, sets up the button to show a tool tip when moused over. Otherwise, removes the tool tip.
cfg.Historia_SetTooltip = function(self, text)
	if text then
		self.tooltipText = text
		self:SetScript("OnEnter", cfg.Historia_Button_OnEnter)
		self:SetScript("OnLeave", cfg.Historia_Button_OnLeave)
	else
		self:SetScript("OnEnter", nil)
		self:SetScript("OnLeave", nil)
	end
end
