--[[	*** Historia ***
Written by : Yukyuk, EU-Moonglade
--]]

-------------------------------------------------------------------------------
--  From _Global to local.
-------------------------------------------------------------------------------
local _G = _G


-------------------------------------------------------------------------------
--  AddOn namespace.
-------------------------------------------------------------------------------
local FOLDER_NAME, private = ...

local cfg = private.cfg
local addon = cfg.addon_name


-------------------------------------------------------------------------------
--  Libstubs.
-------------------------------------------------------------------------------
local L 		= LibStub("AceLocale-3.0"):GetLocale("Historia")
local LibQTip 	= LibStub:GetLibrary("LibQTip-1.0")

local Historia_HIG1_Buttons = 4
local Historia_HIG2_Buttons = 10
local Historia_HIG3_Buttons = 3
local Historia_HIL1_Buttons = 5
local Historia_HIP1_Buttons = 11
local Historia_HIH1_Buttons = 14
local Historia_NUMBEROFRANKS = 14 -- Rank 15 not used

local Historia_HIG1_Text = {1,12,123,1234}
local Historia_HIG2_Text = {1,23,45,67,89,123,456,789,1234,2345}
local Historia_HIG3_Text = {123,456,789}
local Historia_HIL1_Text = {1,23,45,67,89}
local Historia_HIP1_Text = {1,23,45,67,89,123,456,789,1234,2345,3456}


local Historia_HIH1_Text = {1,3,5,7,9,11,15,20,25,30,35,40,45,50}

local Historia_Logos_Alliance = {
	[1] = cfg.Icons .."AllianceRank1",
	[2] = cfg.Icons .."AllianceRank2",
	[3] = cfg.Icons .."AllianceRank3",
	[4] = cfg.Icons .."AllianceRank4",
	[5] = cfg.Icons .."AllianceRank5",
	[6] = cfg.Icons .."AllianceRank6",
	[7] = cfg.Icons .."AllianceRank7",
	[8] = cfg.Icons .."AllianceRank8",
	[9] = cfg.Icons .."AllianceRank9",
	[10] = cfg.Icons .."AllianceRank10",
	[11] = cfg.Icons .."AllianceRank11",
	[12] = cfg.Icons .."AllianceRank12",
	[13] = cfg.Icons .."AllianceRank13",	
	[14] = cfg.Icons .."AllianceRank14",
	[15] = cfg.Icons .."AllianceRank15",	
}

local Historia_Text_Alliance = {
	[1] = {[1] = L["Private"],		[2] = ""},
	[2] = {[1] = L["Corporal"],		[2] = ""},
	[3] = {[1] = L["Sergeant"],		[2] = ""},
	[4] = {[1] = L["Master"],		[2] = L["Sergeant"]},
	[5] = {[1] = L["Sergeant"],		[2] = L["Major"]},
	[6] = {[1] = L["Knight"],		[2] = ""},
	[7] = {[1] = L["Knight"],		[2] = L["Lieutenant"]},
	[8] = {[1] = L["Knight"],		[2] = L["Captain"]},
	[9] = {[1] = L["Knight"],		[2] = L["Champion"]},
	[10] = {[1] = L["Lieutenant"],	[2] = L["Commander"]},
	[11] = {[1] = L["Commander"],	[2] = ""},
	[12] = {[1] = L["Marshal"],		[2] = ""},
	[13] = {[1] = L["Field"],		[2] = L["Marshal"]},
	[14] = {[1] = L["Grand"],		[2] = L["Marshal"]},
	[15] = {[1] = L["Alliance"],	[2] = L["Champion"]},
}

local Historia_Logos_Neutral = {
	[1] = cfg.Icons .."NeutralRank1",
	[2] = cfg.Icons .."NeutralRank2",
	[3] = cfg.Icons .."NeutralRank3",
	[4] = cfg.Icons .."NeutralRank4",
	[5] = cfg.Icons .."NeutralRank5",
	[6] = cfg.Icons .."NeutralRank6",
	[7] = cfg.Icons .."NeutralRank7",
	[8] = cfg.Icons .."NeutralRank8",
	[9] = cfg.Icons .."NeutralRank9",
	[10] = cfg.Icons .."NeutralRank10",
	[11] = cfg.Icons .."NeutralRank11",
	[12] = cfg.Icons .."NeutralRank12",
	[13] = cfg.Icons .."NeutralRank13",	
	[14] = cfg.Icons .."NeutralRank14",
	[15] = cfg.Icons .."NeutralRank15",	
}

local Historia_Text_Neutral = {
	[1] = {[1] = L["Scout"],		[2] = ""},
	[2] = {[1] = L["Far"],			[2] = L["Scout"]},
	[3] = {[1] = L["Walker"],		[2] = ""},
	[4] = {[1] = L["Far"],			[2] = L["Walker"]},
	[5] = {[1] = L["Wanderer"],		[2] = ""},
	[6] = {[1] = L["Wisdom"],		[2] = L["Walker"]},
	[7] = {[1] = L["Accolite"],		[2] = ""},
	[8] = {[1] = L["Wisdom"],		[2] = L["Accolite"]},
	[9] = {[1] = L["Priest"],		[2] = ""},
	[10] = {[1] = L["Innitiate"],	[2] = ""},
	[11] = {[1] = L["Thruth"],		[2] = L["Seeker"]},
	[12] = {[1] = L["Thruth"],		[2] = L["Finder"]},
	[13] = {[1] = L["Thruth"],		[2] = ""},
	[14] = {[1] = L["Neutral"],		[2] = L["Commander"]},
	[15] = {[1] = L["Neutral"],		[2] = L["Champion"]},
}

local Historia_Logos_Horde = {
	[1] = cfg.Icons .."HordeRank1",
	[2] = cfg.Icons .."HordeRank2",
	[3] = cfg.Icons .."HordeRank3",
	[4] = cfg.Icons .."HordeRank4",
	[5] = cfg.Icons .."HordeRank5",
	[6] = cfg.Icons .."HordeRank6",
	[7] = cfg.Icons .."HordeRank7",
	[8] = cfg.Icons .."HordeRank8",
	[9] = cfg.Icons .."HordeRank9",
	[10] = cfg.Icons .."HordeRank10",
	[11] = cfg.Icons .."HordeRank11",
	[12] = cfg.Icons .."HordeRank12",
	[13] = cfg.Icons .."HordeRank13",	
	[14] = cfg.Icons .."HordeRank14",
	[15] = cfg.Icons .."HordeRank15",	
}

local Historia_Text_Horde = {
	[1] = {[1] = L["Scout"],		[2] = ""},
	[2] = {[1] = L["Grunt"],		[2] = ""},
	[3] = {[1] = L["Sergeant"],		[2] = ""},
	[4] = {[1] = L["Senior"],		[2] = L["Sergeant"]},
	[5] = {[1] = L["First"],		[2] = L["Sergeant"]},
	[6] = {[1] = L["Stone"],		[2] = L["Guard"]},
	[7] = {[1] = L["Blood"],		[2] = L["Guard"]},
	[8] = {[1] = L["Legionnare"],	[2] = ""},
	[9] = {[1] = L["Centurion"],	[2] = ""},
	[10] = {[1] = L["Champion"],	[2] = ""},
	[11] = {[1] = L["Lieutenant"],	[2] = L["General"]},
	[12] = {[1] = L["General"],		[2] = ""},
	[13] = {[1] = L["Warlord"],		[2] = ""},
	[14] = {[1] = L["High"],		[2] = L["Warlord"]},
	[15] = {[1] = L["Horde"],		[2] = L["Champion"]},
}


--------------------------------------------------------------------------------
--  This is the Historia hievements frame
--------------------------------------------------------------------------------	
function Historia_Hievements()
	local Historia_HH = CreateFrame("Frame","Historia_HH",Historia_UI)
	Historia_HH:SetID(1)
	Historia_HH:SetPoint("TOP", "Historia_UI", 0, -16)
	Historia_HH:SetPoint("BOTTOM", "Historia_UI", 0, 16)
	Historia_HH:SetPoint("LEFT", "Historia_UI", 16, 0)
	Historia_HH:SetPoint("RIGHT", "Historia_UI", -16, 0)
	Historia_HH:SetBackdrop(cfg.Historia_backdrop3)
	
	--  Create a frame for the header Hievements info.
	local Historia_HH_H = CreateFrame("Frame","Historia_HH_H",Historia_HH)
	Historia_HH_H:SetPoint("TOPLEFT","Historia_HH",0,0)
	Historia_HH_H:SetPoint("BOTTOMRIGHT","Historia_HH","TOPRIGHT",0,-48)
	Historia_HH_H:SetBackdrop(cfg.Historia_backdrop2)	
	
	Historia_HH_H.F1 = Historia_HH_H:CreateFontString(nil,"ARTWORK","GameFontNormalHuge")
	Historia_HH_H.F1:SetPoint("CENTER","Historia_HH_H",0,0)
	Historia_HH_H.F1:SetText(L["Historia achievements"])

	--  Create a frame for the Hievements rank.
	local Historia_HH_R = CreateFrame("Frame","Historia_HH_R",Historia_HH)
	Historia_HH_R:SetPoint("TOPRIGHT","Historia_HH_H","BOTTOMRIGHT",0,-16)
	Historia_HH_R:SetPoint("BOTTOMLEFT","Historia_HH_H","BOTTOMRIGHT",-196,-212)
	Historia_HH_R:SetBackdrop(cfg.Historia_backdrop2)	

	Historia_HH_R.F1 = Historia_HH_R:CreateFontString(nil,"ARTWORK","GameFontNormalHuge")
	Historia_HH_R.F1:SetPoint("TOP","Historia_HH_R",0,-16)
	Historia_HH_R.F1:SetText(L["Hievement rank"])	
	
	Historia_HH_R.F2 = Historia_HH_R:CreateFontString(nil,"ARTWORK","GameFontNormalHuge")
	Historia_HH_R.F2:SetPoint("BOTTOM","Historia_HH_R",0,40)
	Historia_HH_R.F2:SetText("")
	
	Historia_HH_R.F3 = Historia_HH_R:CreateFontString(nil,"ARTWORK","GameFontNormalHuge")
	Historia_HH_R.F3:SetPoint("BOTTOM","Historia_HH_R",0,16)
	Historia_HH_R.F3:SetText("")	

	Historia_HH_R.icon1 = Historia_HH_R:CreateTexture(nil,"ARTWORK")
	Historia_HH_R.icon1:SetSize(64,64)
	Historia_HH_R.icon1:SetPoint("TOP",0,-60)

	Historia_HIG1_labels()	
	Historia_HIG2_labels()	
	Historia_HIG3_labels()	
	Historia_HIL1_labels()
	Historia_HIP1_labels()
	Historia_HIA1_labels()
	Historia_HIQ1_labels()
	Historia_HIH1_labels()	

	Historia_HH:Hide()
end	


-------------------------------------------------------------------------------
--  Set General part 1 Hievements in the UI
-------------------------------------------------------------------------------
function Historia_HIG1_labels()
	--  Define the container frame for the General part 1 Hievements frame)
	local Historia_HIG1 = CreateFrame("FRAME", "Historia_HIG1", Historia_HH)
	Historia_HIG1:SetPoint("TOPLEFT","Historia_HH_H","BOTTOMLEFT",0,-16)
	Historia_HIG1:SetPoint("BOTTOMRIGHT","Historia_HH_H",0,-64)

	--  Define the font string for the general part 1 Hievements. 
	Historia_HIG1.F1 = Historia_HIG1:CreateFontString(nil, "ARTWORK", "GameFontWhite")
	Historia_HIG1.F1:SetPoint("LEFT" ,"Historia_HIG1", 8, 0)
	Historia_HIG1.F1:SetText(GENERAL .. ":")	
				   
	--  Create the list of buttons that go into the general part 1 Hievements frame
	Historia_HIG1.list = {}
	for i=1,Historia_HIG1_Buttons do
		Historia_HIG1.list[i] = CreateFrame("Button",nil,Historia_HIG1)
		Historia_HIG1.list[i]:SetSize(40,40)
		Historia_HIG1.list[i]:SetPoint("LEFT",Historia_HIG1,(i-1)*44+104, 0)
		Historia_HIG1.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HIG1.list[i]:Show()
		Historia_HIG1.list[i].tooltip = cfg.Historia_SetTooltip(Historia_HIG1.list[i], L["HISTORIA_HIG1_" .. tostring(i)])	
		
		Historia_HIG1.list[i].te1 = Historia_HIG1.list[i]:CreateTexture(nil,"ARTWORK",nil,1)
		Historia_HIG1.list[i].te1:SetSize(20,20)
		Historia_HIG1.list[i].te1:SetTexture(cfg.CTX[2])			
		Historia_HIG1.list[i].te1:SetPoint("TOP",Historia_HIG1.list[i],0,-4)
		Historia_HIG1.list[i].te1:Hide()	
		
		Historia_HIG1.list[i].te2 = Historia_HIG1.list[i]:CreateTexture(nil,"ARTWORK",nil,2)
		Historia_HIG1.list[i].te2:SetSize(20,20)		
		Historia_HIG1.list[i].te2:SetTexture(cfg.CTX[3])			
		Historia_HIG1.list[i].te2:SetPoint("TOP",Historia_HIG1.list[i],0,-4)
		Historia_HIG1.list[i].te2:Show()

		Historia_HIG1.list[i].F1 = Historia_HIG1.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HIG1.list[i].F1:SetPoint("BOTTOM",Historia_HIG1.list[i],0,4)
		Historia_HIG1.list[i].F1:SetText(Historia_HIG1_Text[i])		
	end	
end


-------------------------------------------------------------------------------
--  Set General part 2 Hievements in the UI
-------------------------------------------------------------------------------
function Historia_HIG2_labels()
	--  Define the container frame for the General part 1 Hievements frame)
	local Historia_HIG2 = CreateFrame("FRAME", "Historia_HIG2", Historia_HH)
	Historia_HIG2:SetPoint("TOPLEFT","Historia_HIG1","BOTTOMLEFT",0,0)
	Historia_HIG2:SetPoint("BOTTOMRIGHT","Historia_HIG1",0,-46)
				   
	--  Create the list of buttons that go into the general part 1 Hievements frame
	Historia_HIG2.list = {}
	for i=1,Historia_HIG2_Buttons do
		Historia_HIG2.list[i] = CreateFrame("Button",nil,Historia_HIG2)
		Historia_HIG2.list[i]:SetSize(40,40)
		Historia_HIG2.list[i]:SetPoint("LEFT",Historia_HIG2,(i-1)*44+104, 0)
		Historia_HIG2.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HIG2.list[i]:Show()
		Historia_HIG2.list[i].tooltip = cfg.Historia_SetTooltip(Historia_HIG2.list[i], L["HISTORIA_HIG2_" .. tostring(i)])	
		
		Historia_HIG2.list[i].te1 = Historia_HIG2.list[i]:CreateTexture(nil,"ARTWORK",nil,1)
		Historia_HIG2.list[i].te1:SetSize(20,20)
		Historia_HIG2.list[i].te1:SetTexture(cfg.CTX[2])			
		Historia_HIG2.list[i].te1:SetPoint("TOP",Historia_HIG2.list[i],0,-4)
		Historia_HIG2.list[i].te1:Hide()	
		
		Historia_HIG2.list[i].te2 = Historia_HIG2.list[i]:CreateTexture(nil,"ARTWORK",nil,2)
		Historia_HIG2.list[i].te2:SetSize(20,20)		
		Historia_HIG2.list[i].te2:SetTexture(cfg.CTX[3])			
		Historia_HIG2.list[i].te2:SetPoint("TOP",Historia_HIG2.list[i],0,-4)
		Historia_HIG2.list[i].te2:Show()

		Historia_HIG2.list[i].F1 = Historia_HIG2.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HIG2.list[i].F1:SetPoint("BOTTOM",Historia_HIG2.list[i],0,4)
		Historia_HIG2.list[i].F1:SetText(Historia_HIG2_Text[i])		
	end	
end


-------------------------------------------------------------------------------
--  Set General part 3 Hievements in the UI
-------------------------------------------------------------------------------
function Historia_HIG3_labels()
	--  Define the container frame for the General part 1 Hievements frame)
	local Historia_HIG3 = CreateFrame("FRAME", "Historia_HIG3", Historia_HH)
	Historia_HIG3:SetPoint("TOPLEFT","Historia_HIG2","BOTTOMLEFT",0,0)
	Historia_HIG3:SetPoint("BOTTOMRIGHT","Historia_HIG2",0,-46)
				   
	--  Create the list of buttons that go into the general part 1 Hievements frame
	Historia_HIG3.list = {}
	for i=1,Historia_HIG3_Buttons do
		Historia_HIG3.list[i] = CreateFrame("Button",nil,Historia_HIG3)
		Historia_HIG3.list[i]:SetSize(40,40)
		Historia_HIG3.list[i]:SetPoint("LEFT",Historia_HIG3,(i-1)*44+104, 0)
		Historia_HIG3.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HIG3.list[i]:Show()
		Historia_HIG3.list[i].tooltip = cfg.Historia_SetTooltip(Historia_HIG3.list[i], L["HISTORIA_HIG3_" .. tostring(i)])	
		
		Historia_HIG3.list[i].te1 = Historia_HIG3.list[i]:CreateTexture(nil,"ARTWORK",nil,1)
		Historia_HIG3.list[i].te1:SetSize(20,20)
		Historia_HIG3.list[i].te1:SetTexture(cfg.CTX[2])			
		Historia_HIG3.list[i].te1:SetPoint("TOP",Historia_HIG3.list[i],0,-4)
		Historia_HIG3.list[i].te1:Hide()	
		
		Historia_HIG3.list[i].te2 = Historia_HIG3.list[i]:CreateTexture(nil,"ARTWORK",nil,2)
		Historia_HIG3.list[i].te2:SetSize(20,20)		
		Historia_HIG3.list[i].te2:SetTexture(cfg.CTX[3])			
		Historia_HIG3.list[i].te2:SetPoint("TOP",Historia_HIG3.list[i],0,-4)
		Historia_HIG3.list[i].te2:Show()

		Historia_HIG3.list[i].F1 = Historia_HIG3.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HIG3.list[i].F1:SetPoint("BOTTOM",Historia_HIG3.list[i],0,4)
		Historia_HIG3.list[i].F1:SetText(Historia_HIG3_Text[i])		
	end	
end


-------------------------------------------------------------------------------
--  Set Levels part 1 Hievements in the UI
-------------------------------------------------------------------------------
function Historia_HIL1_labels()
	--  Define the container frame for the General part 1 Hievements frame)
	local Historia_HIL1 = CreateFrame("FRAME", "Historia_HIL1", Historia_HH)
	Historia_HIL1:SetPoint("TOPLEFT","Historia_HIG3","BOTTOMLEFT",0,0)
	Historia_HIL1:SetPoint("BOTTOMRIGHT","Historia_HIG3",0,-46)

	--  Define the font string for the general part 1 Hievements. 
	Historia_HIL1.F1 = Historia_HIL1:CreateFontString(nil, "ARTWORK", "GameFontWhite")
	Historia_HIL1.F1:SetPoint("LEFT" ,"Historia_HIL1", 8, 0)
	Historia_HIL1.F1:SetText(L["Levels"] .. ":")	
				   
	--  Create the list of buttons that go into the general part 1 Hievements frame
	Historia_HIL1.list = {}
	for i=1,Historia_HIL1_Buttons do
		Historia_HIL1.list[i] = CreateFrame("Button",nil,Historia_HIL1)
		Historia_HIL1.list[i]:SetSize(40,40)
		Historia_HIL1.list[i]:SetPoint("LEFT",Historia_HIL1,(i-1)*44+104, 0)
		Historia_HIL1.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HIL1.list[i]:Show()
		Historia_HIL1.list[i].tooltip = cfg.Historia_SetTooltip(Historia_HIL1.list[i], L["HISTORIA_HIL1_" .. tostring(i)])
		
		Historia_HIL1.list[i].te1 = Historia_HIL1.list[i]:CreateTexture(nil,"ARTWORK",nil,1)
		Historia_HIL1.list[i].te1:SetSize(20,20)
		Historia_HIL1.list[i].te1:SetTexture(cfg.CTX[2])			
		Historia_HIL1.list[i].te1:SetPoint("TOP",Historia_HIL1.list[i],0,-4)
		Historia_HIL1.list[i].te1:Hide()	
		
		Historia_HIL1.list[i].te2 = Historia_HIL1.list[i]:CreateTexture(nil,"ARTWORK",nil,2)
		Historia_HIL1.list[i].te2:SetSize(20,20)		
		Historia_HIL1.list[i].te2:SetTexture(cfg.CTX[3])			
		Historia_HIL1.list[i].te2:SetPoint("TOP",Historia_HIL1.list[i],0,-4)
		Historia_HIL1.list[i].te2:Show()

		Historia_HIL1.list[i].F1 = Historia_HIL1.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HIL1.list[i].F1:SetPoint("BOTTOM",Historia_HIL1.list[i],0,4)
		Historia_HIL1.list[i].F1:SetText(Historia_HIL1_Text[i])		
	end	
end


-------------------------------------------------------------------------------
--  Set Professions part 1 Hievements in the UI
-------------------------------------------------------------------------------
function Historia_HIP1_labels()
	--  Define the container frame for the General part 1 Hievements frame)
	local Historia_HIP1 = CreateFrame("FRAME", "Historia_HIP1", Historia_HH)
	Historia_HIP1:SetPoint("TOPLEFT","Historia_HIL1","BOTTOMLEFT",0,0)
	Historia_HIP1:SetPoint("BOTTOMRIGHT","Historia_HIL1",0,-46)

	--  Define the font string for the general part 1 Hievements. 
	Historia_HIP1.F1 = Historia_HIP1:CreateFontString(nil, "ARTWORK", "GameFontWhite")
	Historia_HIP1.F1:SetPoint("LEFT" ,"Historia_HIP1", 8, 0)
	Historia_HIP1.F1:SetText(TUTORIAL_TITLE38 .. ":")	
				   
	--  Create the list of buttons that go into the general part 1 Hievements frame
	Historia_HIP1.list = {}
	for i=1,Historia_HIP1_Buttons do
		Historia_HIP1.list[i] = CreateFrame("Button",nil,Historia_HIP1)
		Historia_HIP1.list[i]:SetSize(40,40)
		Historia_HIP1.list[i]:SetPoint("LEFT",Historia_HIP1,(i-1)*44+104, 0)
		Historia_HIP1.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HIP1.list[i]:Show()
		Historia_HIP1.list[i].tooltip = cfg.Historia_SetTooltip(Historia_HIP1.list[i], L["HISTORIA_HIP1_" .. tostring(i)])
		
		Historia_HIP1.list[i].te1 = Historia_HIP1.list[i]:CreateTexture(nil,"ARTWORK",nil,1)
		Historia_HIP1.list[i].te1:SetSize(20,20)
		Historia_HIP1.list[i].te1:SetTexture(cfg.CTX[2])			
		Historia_HIP1.list[i].te1:SetPoint("TOP",Historia_HIP1.list[i],0,-4)
		Historia_HIP1.list[i].te1:Hide()	
		
		Historia_HIP1.list[i].te2 = Historia_HIP1.list[i]:CreateTexture(nil,"ARTWORK",nil,2)
		Historia_HIP1.list[i].te2:SetSize(20,20)		
		Historia_HIP1.list[i].te2:SetTexture(cfg.CTX[3])			
		Historia_HIP1.list[i].te2:SetPoint("TOP",Historia_HIP1.list[i],0,-4)
		Historia_HIP1.list[i].te2:Show()

		Historia_HIP1.list[i].F1 = Historia_HIP1.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HIP1.list[i].F1:SetPoint("BOTTOM",Historia_HIP1.list[i],0,4)
		Historia_HIP1.list[i].F1:SetText(Historia_HIP1_Text[i])		
	end	
end


-------------------------------------------------------------------------------
--  Set Achievements part 1 Hievements in the UI
-------------------------------------------------------------------------------
function Historia_HIA1_labels()
	--  Define the container frame for the General part 1 Hievements frame)
	local Historia_HIA1 = CreateFrame("FRAME", "Historia_HIA1", Historia_HH)
	Historia_HIA1:SetPoint("TOPLEFT","Historia_HIP1","BOTTOMLEFT",0,0)
	Historia_HIA1:SetPoint("BOTTOMRIGHT","Historia_HIP1",0,-46)

	--  Define the font string for the general part 1 Hievements. 
	Historia_HIA1.F1 = Historia_HIA1:CreateFontString(nil, "ARTWORK", "GameFontWhite")
	Historia_HIA1.F1:SetPoint("LEFT" ,"Historia_HIA1", 8, 0)
	Historia_HIA1.F1:SetText(ACHIEVEMENTS .. ":")	
				   
	--  Create the list of buttons that go into the general part 1 Hievements frame
	Historia_HIA1.list = {}
	for i=1,cfg.Historia_HIA1_Buttons do
		Historia_HIA1.list[i] = CreateFrame("Button",nil,Historia_HIA1)
		Historia_HIA1.list[i]:SetSize(40,40)
		Historia_HIA1.list[i]:SetPoint("LEFT",Historia_HIA1,(i-1)*44+104, 0)
		Historia_HIA1.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HIA1.list[i]:Show()
		Historia_HIA1.list[i].tooltip = cfg.Historia_SetTooltip(Historia_HIA1.list[i], L["HISTORIA_HIA1_" .. tostring(i)])
		
		Historia_HIA1.list[i].te1 = Historia_HIA1.list[i]:CreateTexture(nil,"ARTWORK",nil,1)
		Historia_HIA1.list[i].te1:SetSize(20,20)
		Historia_HIA1.list[i].te1:SetTexture(cfg.CTX[2])			
		Historia_HIA1.list[i].te1:SetPoint("TOP",Historia_HIA1.list[i],0,-4)
		Historia_HIA1.list[i].te1:Hide()	
		
		Historia_HIA1.list[i].te2 = Historia_HIA1.list[i]:CreateTexture(nil,"ARTWORK",nil,2)
		Historia_HIA1.list[i].te2:SetSize(20,20)		
		Historia_HIA1.list[i].te2:SetTexture(cfg.CTX[3])			
		Historia_HIA1.list[i].te2:SetPoint("TOP",Historia_HIA1.list[i],0,-4)
		Historia_HIA1.list[i].te2:Show()

		Historia_HIA1.list[i].F1 = Historia_HIA1.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HIA1.list[i].F1:SetPoint("BOTTOM",Historia_HIA1.list[i],0,4)
		Historia_HIA1.list[i].F1:SetText(cfg.Historia_HIA1_Text[i])		
	end	
end


-------------------------------------------------------------------------------
--  Set Quests part 1 Hievements in the UI
-------------------------------------------------------------------------------
function Historia_HIQ1_labels()
	--  Define the container frame for the General part 1 Hievements frame)
	local Historia_HIQ1 = CreateFrame("FRAME", "Historia_HIQ1", Historia_HH)
	Historia_HIQ1:SetPoint("TOPLEFT","Historia_HIA1","BOTTOMLEFT",0,0)
	Historia_HIQ1:SetPoint("BOTTOMRIGHT","Historia_HIA1",0,-46)

	--  Define the font string for the general part 1 Hievements. 
	Historia_HIQ1.F1 = Historia_HIQ1:CreateFontString(nil, "ARTWORK", "GameFontWhite")
	Historia_HIQ1.F1:SetPoint("LEFT" ,"Historia_HIQ1", 8, 0)
	Historia_HIQ1.F1:SetText(QUESTS_LABEL .. ":")	
				   
	--  Create the list of buttons that go into the general part 1 Hievements frame
	Historia_HIQ1.list = {}
	for i=1,cfg.Historia_HIQ1_Buttons do
		Historia_HIQ1.list[i] = CreateFrame("Button",nil,Historia_HIQ1)
		Historia_HIQ1.list[i]:SetSize(40,40)
		Historia_HIQ1.list[i]:SetPoint("LEFT",Historia_HIQ1,(i-1)*44+104, 0)
		Historia_HIQ1.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HIQ1.list[i]:Show()
		Historia_HIQ1.list[i].tooltip = cfg.Historia_SetTooltip(Historia_HIQ1.list[i], L["HISTORIA_HIQ1_" .. tostring(i)])
		
		Historia_HIQ1.list[i].te1 = Historia_HIQ1.list[i]:CreateTexture(nil,"ARTWORK",nil,1)
		Historia_HIQ1.list[i].te1:SetSize(20,20)
		Historia_HIQ1.list[i].te1:SetTexture(cfg.CTX[2])			
		Historia_HIQ1.list[i].te1:SetPoint("TOP",Historia_HIQ1.list[i],0,-4)
		Historia_HIQ1.list[i].te1:Hide()	
		
		Historia_HIQ1.list[i].te2 = Historia_HIQ1.list[i]:CreateTexture(nil,"ARTWORK",nil,2)
		Historia_HIQ1.list[i].te2:SetSize(20,20)		
		Historia_HIQ1.list[i].te2:SetTexture(cfg.CTX[3])			
		Historia_HIQ1.list[i].te2:SetPoint("TOP",Historia_HIQ1.list[i],0,-4)
		Historia_HIQ1.list[i].te2:Show()

		Historia_HIQ1.list[i].F1 = Historia_HIQ1.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HIQ1.list[i].F1:SetPoint("BOTTOM",Historia_HIQ1.list[i],0,4)
		Historia_HIQ1.list[i].F1:SetText(cfg.Historia_HIQ1_Text[i])		
	end	
end


-------------------------------------------------------------------------------
--  Set Hievements part 1 in the UI
-------------------------------------------------------------------------------
function Historia_HIH1_labels()
	--  Define the container frame for the General part 1 Hievements frame)
	local Historia_HIH1 = CreateFrame("FRAME", "Historia_HIH1", Historia_HH)
	Historia_HIH1:SetPoint("TOPLEFT","Historia_HIQ1","BOTTOMLEFT",0,0)
	Historia_HIH1:SetPoint("BOTTOMRIGHT","Historia_HIQ1",0,-46)

	--  Define the font string for the general part 1 Hievements. 
	Historia_HIH1.F1 = Historia_HIH1:CreateFontString(nil, "ARTWORK", "GameFontWhite")
	Historia_HIH1.F1:SetPoint("LEFT" ,"Historia_HIH1", 8, 0)
	Historia_HIH1.F1:SetText(L["Hievements"] .. ":")	
				   
	--  Create the list of buttons that go into the general part 1 Hievements frame
	Historia_HIH1.list = {}
	for i=1,Historia_HIH1_Buttons do
		Historia_HIH1.list[i] = CreateFrame("Button",nil,Historia_HIH1)
		Historia_HIH1.list[i]:SetSize(40,40)
		Historia_HIH1.list[i]:SetPoint("LEFT",Historia_HIH1,(i-1)*44+104, 0)
		Historia_HIH1.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HIH1.list[i]:Show()
		Historia_HIH1.list[i].tooltip = cfg.Historia_SetTooltip(Historia_HIH1.list[i], L["HISTORIA_HIH1_" .. tostring(i)])
		
		Historia_HIH1.list[i].te1 = Historia_HIH1.list[i]:CreateTexture(nil,"ARTWORK",nil,1)
		Historia_HIH1.list[i].te1:SetSize(20,20)
		Historia_HIH1.list[i].te1:SetTexture(cfg.CTX[2])			
		Historia_HIH1.list[i].te1:SetPoint("TOP",Historia_HIH1.list[i],0,-4)
		Historia_HIH1.list[i].te1:Hide()	
		
		Historia_HIH1.list[i].te2 = Historia_HIH1.list[i]:CreateTexture(nil,"ARTWORK",nil,2)
		Historia_HIH1.list[i].te2:SetSize(20,20)		
		Historia_HIH1.list[i].te2:SetTexture(cfg.CTX[3])			
		Historia_HIH1.list[i].te2:SetPoint("TOP",Historia_HIH1.list[i],0,-4)
		Historia_HIH1.list[i].te2:Show()

		Historia_HIH1.list[i].F1 = Historia_HIH1.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HIH1.list[i].F1:SetPoint("BOTTOM",Historia_HIH1.list[i],0,4)
		Historia_HIH1.list[i].F1:SetText(Historia_HIH1_Text[i])		
	end	
end


-------------------------------------------------------------------------------
--  Determine how much gold you have earned/spent
-------------------------------------------------------------------------------
--  For gold earned/spent per day
local Best_day = -999999999
local Worst_day = 999999999

local Historia_NUMBER_OF_YEARS = 10
local Historia_NUMBER_OF_MONTHS = 12
local Historia_NUMBER_OF_DAYS = 31
local DTY = {"2015", "2016", "2017", "2018", "2019", "2020", "2021", "2022", "2023", "2024"}
local DTM = {"01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12"}
local DTD = {"01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31"}

local function updateHievementsCurrency()
	for i = 1, Historia_NUMBER_OF_YEARS do
		if HistoriaLocalDb.Dates[DTY[i]] ~= nil then
			for j = 1, Historia_NUMBER_OF_MONTHS do
				if HistoriaLocalDb.Dates[DTY[i]][DTM[j]] ~= nil then
					for k = 1, Historia_NUMBER_OF_DAYS do
						if HistoriaLocalDb.Dates[DTY[i]][DTM[j]][DTD[k]] ~= nil then
							local amount_bwd = HistoriaLocalDb.Dates[DTY[i]][DTM[j]][DTD[k]].Gold_Current - HistoriaLocalDb.Dates[DTY[i]][DTM[j]][DTD[k]].Gold_Start
							if amount_bwd > Best_day then
								Best_day = amount_bwd
							end
							if amount_bwd <= Worst_day then
								Worst_day = amount_bwd
							end
						end
					end					
				end
			end 
		end	
	end	
end


-------------------------------------------------------------------------------
--	Show the correct achievements
-------------------------------------------------------------------------------
function Historia_Show_Hievements()
	local Historia_HC = 0
	
	for i = 1, Historia_HIG1_Buttons do
		if HistoriaLocalDb.Enter_count >= Historia_HIG1_Text[i] then
			Historia_HIG1.list[i].te1:Show()	
			Historia_HIG1.list[i].te2:Hide()	
			Historia_HC = Historia_HC + 1
		end	
	end	

	updateHievementsCurrency()

	for i = 1, Historia_HIG2_Buttons do
		if Best_day > (Historia_HIG2_Text[i] * 10000) then
			Historia_HIG2.list[i].te1:Show()	
			Historia_HIG2.list[i].te2:Hide()	
			Historia_HC = Historia_HC + 1
		end	
	end	

	if Worst_day < 0 then
		Worst_day = Worst_day * -1
	end	
	
	for i = 1, Historia_HIG3_Buttons do
		if Worst_day > (Historia_HIG3_Text[i] * 10000) then
			Historia_HIG3.list[i].te1:Show()	
			Historia_HIG3.list[i].te2:Hide()	
			Historia_HC = Historia_HC + 1
		end	
	end		
	
	for i = 1, Historia_HIL1_Buttons do
		if #HistoriaLocalDb.Level >= Historia_HIL1_Text[i] then
			Historia_HIL1.list[i].te1:Show()	
			Historia_HIL1.list[i].te2:Hide()	
			Historia_HC = Historia_HC + 1
		end	
	end	
	
	for i = 1, Historia_HIP1_Buttons do
		if #HistoriaLocalDb.Professions >= Historia_HIP1_Text[i] then
			Historia_HIP1.list[i].te1:Show()	
			Historia_HIP1.list[i].te2:Hide()	
			Historia_HC = Historia_HC + 1
		end	
	end		
	
	for i = 1, cfg.Historia_HIA1_Buttons do
		if #HistoriaLocalDb.Achievements >= cfg.Historia_HIA1_Text[i] then
			Historia_HIA1.list[i].te1:Show()	
			Historia_HIA1.list[i].te2:Hide()	
			Historia_HC = Historia_HC + 1
		end	
	end	

	for i = 1, cfg.Historia_HIQ1_Buttons do
		if #HistoriaLocalDb.Quests >= cfg.Historia_HIQ1_Text[i] then
			Historia_HIQ1.list[i].te1:Show()	
			Historia_HIQ1.list[i].te2:Hide()	
			Historia_HC = Historia_HC + 1
		end	
	end	

	for i = 1, Historia_HIH1_Buttons do
		if Historia_HC >= Historia_HIH1_Text[i] then
			Historia_HIH1.list[i].te1:Show()	
			Historia_HIH1.list[i].te2:Hide()	
		end	
	end	

	for i = 1, Historia_NUMBEROFRANKS do
		if Historia_HC >= Historia_HIH1_Text[i] then
			if cfg.PLAYER_FACTION == FACTION_ALLIANCE then
				Historia_HH_R.F2:SetText(Historia_Text_Alliance[i][1])
				Historia_HH_R.F3:SetText(Historia_Text_Alliance[i][2])
				Historia_HH_R.icon1:SetTexture(Historia_Logos_Alliance[i])
			elseif cfg.PLAYER_FACTION == FACTION_HORDE then
				Historia_HH_R.F2:SetText(Historia_Text_Horde[i][1])
				Historia_HH_R.F3:SetText(Historia_Text_Horde[i][2])
				Historia_HH_R.icon1:SetTexture(Historia_Logos_Horde[i])	
			else
				Historia_HH_R.F2:SetText(Historia_Text_Neutral[i][1])
				Historia_HH_R.F3:SetText(Historia_Text_Neutral[i][2])
				Historia_HH_R.icon1:SetTexture(Historia_Logos_Neutral[i])
			end	
		end
	end	
end


-------------------------------------------------------------------------------
--  Handle the Hievements Tab
-------------------------------------------------------------------------------
function Historia_HH_Update()
	Historia_Show_Hievements()
end
