--[[	*** Historia ***
Written by : Yukyuk, EU-Moonglade
--]]

-------------------------------------------------------------------------------
--  From _Global to local.
-------------------------------------------------------------------------------
local _G = _G


-------------------------------------------------------------------------------
--  AddOn namespace.
-------------------------------------------------------------------------------
local FOLDER_NAME, private = ...

local cfg = private.cfg
local addon = cfg.addon_name


-------------------------------------------------------------------------------
--  Libstubs.
-------------------------------------------------------------------------------
local L 				= LibStub("AceLocale-3.0"):GetLocale("Historia")
local LibQTip 			= LibStub:GetLibrary("LibQTip-1.0")


-------------------------------------------------------------------------------
--	Local constants
-------------------------------------------------------------------------------
local row_count = 0
local Historia_HP_NO_SCROLLBUTTONS = 24			--  number of scroll buttons for the professions frame
local Historia_NUMBEROFPROFESSIONSTABS = 12		--	number of selection buttons in the professions tab
local Historia_Professions_Tab = {}				--	this variable holds the selection buttons
local Historia_Professions_Table = {}			--	this varaible holds the professions dates selected from the database
local Historia_Professions_Scroll_Table = {}	--	this variable holds the selected lines that go into the scroll table
local Historia_Profession_Tabs = {}				--	this table holds the (shown) SkillId's 

--  Define the initial icon of the professions tab .
 local Professions_icon = {
	[1] = "Interface\\ICONS\\INV_Misc_QuestionMark",
}


--------------------------------------------------------------------------------
--  This is the Historia professions frame
--------------------------------------------------------------------------------	
function Historia_Professions()
	local Historia_HP = CreateFrame("Frame","Historia_HP",Historia_UI)
	Historia_HP:SetID(1)
	Historia_HP:SetPoint("TOP", "Historia_UI", 0, -16)
	Historia_HP:SetPoint("BOTTOM", "Historia_UI", 0, 16)
	Historia_HP:SetPoint("LEFT", "Historia_UI", 16, 0)
	Historia_HP:SetPoint("RIGHT", "Historia_UI", -16, 0)
	Historia_HP:SetBackdrop(cfg.Historia_backdrop3)
	
	--  Create a frame for the header Professions info.
	local Historia_HP_H = CreateFrame("Frame","Historia_HP_H",Historia_HP)
	Historia_HP_H:SetPoint("TOPLEFT","Historia_HP",0,0)
	Historia_HP_H:SetPoint("BOTTOMRIGHT","Historia_HP","TOPRIGHT",0,-48)
	Historia_HP_H:SetBackdrop(cfg.Historia_backdrop2)	
	
	Historia_HP_H.F1 = Historia_HP_H:CreateFontString(nil,"ARTWORK","GameFontNormalHuge")
	Historia_HP_H.F1:SetPoint("CENTER","Historia_HP_H",0,0)
	Historia_HP_H.F1:SetText(L["History of:"] .. " " .. TUTORIAL_TITLE38)	
	
	Historia_Professions_Scrollframe()
	Historia_Professions_TheRest()	

	Historia_HP:Hide()
end	


-------------------------------------------------------------------------------
--  Fill the Professions scroll table
-------------------------------------------------------------------------------
function Historia_Professions_Scrollframe()
	--  Create a reference frame for the rest of the Professions info.
	local Historia_HP_I = CreateFrame("Frame","Historia_HP_I",Historia_HP)
	Historia_HP_I:SetPoint("TOPLEFT", "Historia_HP_H", "BOTTOMLEFT", 0, -16)
	Historia_HP_I:SetPoint("BOTTOMRIGHT", "Historia_HP", "BOTTOMRIGHT", 0, 0)
	local Historia_HP_I_Width = Historia_HP_I:GetWidth()	
	local Historia_HP_I_Height = Historia_HP_I:GetHeight()

	--  Create a frame for the header Professions text.
	local Historia_HP_IH = CreateFrame("Frame","Historia_HP_IH",Historia_HP_I)
	Historia_HP_IH:SetPoint("TOPLEFT","Historia_HP_I",0,0)
	Historia_HP_IH:SetPoint("BOTTOMRIGHT","Historia_HP_I","TOPLEFT",400,-24)
	Historia_HP_IH:SetBackdrop(cfg.Historia_backdrop2)	
	
	Historia_HP_IH.F1 = Historia_HP_IH:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HP_IH.F1:SetPoint("CENTER","Historia_HP_IH",0,0)
	Historia_HP_IH.F1:SetText("")	
	
	--  Create the container for the Professions scroll frame.
	local HPSF1 = CreateFrame("Frame","HPSF1",Historia_HP_I)
	HPSF1:SetPoint("TOPLEFT", "Historia_HP_I", "TOPLEFT", 0, -24)
	HPSF1:SetPoint("BOTTOMRIGHT", "Historia_HP_I", "TOPLEFT", 400, Historia_HP_I_Height*-1)
	HPSF1:SetBackdrop((cfg.Historia_backdrop2))

	--  Create the container for the Professions scroll bar.
	local HPSF1_bar = CreateFrame("Frame","HPSF1_bar",HPSF1)
	HPSF1_bar:SetPoint("TOPRIGHT", "HPSF1", 0, 0)
	HPSF1_bar:SetPoint("BOTTOMLEFT", "HPSF1", "BOTTOMRIGHT", -24, 0)
	HPSF1_bar:SetBackdrop(cfg.Historia_backdrop2)	

	--  Create the list of buttons that go into the Professions scroll frame
	HPSF1.list = {}
	for i=1,Historia_HP_NO_SCROLLBUTTONS do
		HPSF1.list[i] = CreateFrame("Button",nil,HPSF1)
		HPSF1.list[i]:SetSize(400,16)
		HPSF1.list[i]:SetPoint("TOPLEFT",HPSF1,"TOPLEFT",8,(i-1)*-16-4)
		HPSF1.list[i]:Show()
		
		HPSF1.list[i].name1 = HPSF1.list[i]:CreateFontString(nil,"ARTWORK","GameFontWhite")
		HPSF1.list[i].name1:SetSize(160,16)
		HPSF1.list[i].name1:SetPoint("LEFT",0,0)	
		HPSF1.list[i].name1:SetJustifyH("LEFT") 

		HPSF1.list[i].name2 = HPSF1.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		HPSF1.list[i].name2:SetSize(32,16)
		HPSF1.list[i].name2:SetPoint("LEFT", HPSF1.list[i].name1, "RIGHT",4,0)
		HPSF1.list[i].name2:SetJustifyH("LEFT") 

		HPSF1.list[i].name3 = HPSF1.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		HPSF1.list[i].name3:SetSize(200,16)
		HPSF1.list[i].name3:SetPoint("LEFT", HPSF1.list[i].name2, "RIGHT",4,0)
		HPSF1.list[i].name3:SetJustifyH("LEFT") 		
	end	
	
	-- 	Create the scroll frame
	HPSF1.scrollFrame = CreateFrame("ScrollFrame","HPSF1_scrollFrame",HPSF1,"FauxScrollFrameTemplate")
	HPSF1.scrollFrame:SetPoint("TOPLEFT",HPSF1,"TOPLEFT",0,-2)
	HPSF1.scrollFrame:SetPoint("BOTTOMRIGHT",HPSF1,"BOTTOMRIGHT",-26,2)
	HPSF1.scrollFrame:SetScript("OnVerticalScroll",function(self,offset)
	FauxScrollFrame_OnVerticalScroll(self,offset,16,HPSF1_ScrollFrameUpdate)
	end)	
	
		--	Create the professions buttons
	for i = 1,Historia_NUMBEROFPROFESSIONSTABS do
		Historia_Professions_Tab[i] = CreateFrame("Button",nil,Historia_HP_I)
		Historia_Professions_Tab[i]:SetSize(32,32)
		Historia_Professions_Tab[i]:SetPoint("TOPLEFT",HPSF1,"TOPRIGHT",0,(i-1)*-32)
		Historia_Professions_Tab[i]:SetBackdrop(cfg.Historia_backdrop0)
		Historia_Professions_Tab[i]:Show()
		Historia_Professions_Tab[i]:SetScript("OnClick", function(self, button)
			Historia_HP_Build_Table(i)		
		end)	
		Historia_Professions_Tab[i]:SetScript("OnEnter", function(self, button)
			Historia_Professions_Tab[i].te1:Show()
		end)		
		Historia_Professions_Tab[i]:SetScript("OnLeave", function(self, button)
			Historia_Professions_Tab[i].te1:Hide()
		end)		
		
		Historia_Professions_Tab[i].te1 = Historia_Professions_Tab[i]:CreateTexture(nil,"ARTWORK")
		Historia_Professions_Tab[i].te1:SetTexture("Interface\\ContainerFrame\\UI-Icon-QuestBorder")
		Historia_Professions_Tab[i].te1:SetPoint("TOPLEFT", Historia_Professions_Tab[i], 2, -2)
		Historia_Professions_Tab[i].te1:SetPoint("BOTTOMRIGHT", Historia_Professions_Tab[i], -2, 2)	
		Historia_Professions_Tab[i].te1:Hide()
		
		Historia_Professions_Tab[i].te2 = Historia_Professions_Tab[i]:CreateTexture(nil,"ARTWORK")
		Historia_Professions_Tab[i].te2:SetTexture(Professions_icon[1])
		Historia_Professions_Tab[i].te2:SetPoint("TOPLEFT", Historia_Professions_Tab[i], 4, -4)
		Historia_Professions_Tab[i].te2:SetPoint("BOTTOMRIGHT", Historia_Professions_Tab[i], -4, 4)	
		Historia_Professions_Tab[i].te2:Show()		
	end	
end 


-------------------------------------------------------------------------------
--  Fill the Professions scroll table
--	Fill the extensions part
-------------------------------------------------------------------------------
function Historia_HP_Build_Table(id)
	row_count = 0
	Historia_Professions_Table = {}
	Historia_Professions_Scroll_Table = {}	

	for idx = 1, #HistoriaLocalDb.Professions do
		if HistoriaLocalDb.Professions[idx].skillLine == Historia_Profession_Tabs[id] then
			Historia_Professions_Table = {}
			row_count = row_count + 1
			--	Set the professions name above the scroll frame
			if row_count ==  1 then
				Historia_HP_IH.F1:SetText(HistoriaLocalDb.Professions[idx].name)
			end	
		
			Historia_Professions_Table.Text		= HistoriaLocalDb.Professions[idx].name
			Historia_Professions_Table.Rank		= HistoriaLocalDb.Professions[idx].rank
			Historia_Professions_Table.Time		= HistoriaLocalDb.Professions[idx].time
			Historia_Professions_Table.Expansion	= HistoriaLocalDb.Professions[idx].expansion
			tinsert(Historia_Professions_Scroll_Table,1,Historia_Professions_Table)
		end	
	end	
	
	HPSF1.scrollFrame.ScrollBar:SetValue(0)	
	HPSF1_ScrollFrameUpdate()
end	


-------------------------------------------------------------------------------
--  Professions scroll table the scrolling part.
-------------------------------------------------------------------------------
function HPSF1_ScrollFrameUpdate()
	local offset = FauxScrollFrame_GetOffset(HPSF1.scrollFrame)
	FauxScrollFrame_Update(HPSF1.scrollFrame, row_count, Historia_HP_NO_SCROLLBUTTONS, 16)

	for i = 1, Historia_HP_NO_SCROLLBUTTONS do
		local idx = offset + i
		if idx <= row_count then
			HPSF1.list[i].name1:SetText(format(date("%a, %b %d %Y %H:%M", Historia_Professions_Scroll_Table[idx].Time)))
			if Historia_Professions_Scroll_Table[idx].Rank == 99999 then
				HPSF1.list[i].name2:SetText(NONE)
			else	
				HPSF1.list[i].name2:SetText(Historia_Professions_Scroll_Table[idx].Rank)
			end
			if Historia_Professions_Scroll_Table[idx].Expansion ~= NO then
				HPSF1.list[i].name3:SetText(cfg.colors[Historia_Professions_Scroll_Table[idx].Expansion] .. Historia_Professions_Scroll_Table[idx].Expansion .. cfg.colors["End"])
			else
				HPSF1.list[i].name3:SetText("")
			end	
			HPSF1.list[i]:Show()
		else
			HPSF1.list[i]:Hide()
		end	
	end	
end


-------------------------------------------------------------------------------
--	Properly fill the professions tabs
-------------------------------------------------------------------------------
local function PTX_Tabs()
	--	First properly fill the PTX table
	for i = 1, #HistoriaLocalDb.Professions do
		for j = 1, cfg.PTX_Relevant do
			if HistoriaLocalDb.Professions[i].skillLine == cfg.PTX[j][1] then
				cfg.PTX[j][4] = true
			end
		end
	end
	
	local idx = 0
	Historia_Profession_Tabs = {}
	--	Fill and show/hide the profession buttons
	for i = 1, cfg.PTX_Relevant do
		if cfg.PTX[i][4] then
			idx = idx + 1 
			if idx <= Historia_NUMBEROFPROFESSIONSTABS then
				Historia_Professions_Tab[idx].te2:SetTexture(cfg.PTX[i][3])
				Historia_Professions_Tab[idx]:Show()
				Historia_Profession_Tabs[idx] = cfg.PTX[i][1] 
			end	
		end
	end
	
	--	Hide the buttons that are not used
	idx = idx + 1
	if idx < Historia_NUMBEROFPROFESSIONSTABS then
		for i = idx, Historia_NUMBEROFPROFESSIONSTABS do
			Historia_Professions_Tab[i]:Hide()
		end
	end
end



-------------------------------------------------------------------------------
--	Create the rest of the professions frame
-------------------------------------------------------------------------------
function Historia_Professions_TheRest()

end


-------------------------------------------------------------------------------
--	Handle and fill the rest of the professions frame
-------------------------------------------------------------------------------
function Handle_Professions_TheRest()

end


-------------------------------------------------------------------------------
--  Handle the Professions Tab
-------------------------------------------------------------------------------
function Historia_HP_Update()
	--  Properly fill the professions tabs
	PTX_Tabs()
	--	Fill the Scroll table and the rest
	Historia_HP_Build_Table(1)
	Handle_Professions_TheRest()
end